import React from 'react';
import PropTypes from 'prop-types';
import fetch from 'isomorphic-unfetch';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function childrenToArray(children) {
  return Array.isArray && Array.isArray(children) ? children : [].concat(children);
}

var Holen = function (_React$Component) {
  _inherits(Holen, _React$Component);

  function Holen(props) {
    _classCallCheck(this, Holen);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.state = {
      fetching: !props.lazy,
      response: undefined,
      data: undefined,
      error: undefined
    };

    _this.doFetch = _this.doFetch.bind(_this);
    return _this;
  }

  Holen.prototype.componentDidMount = function componentDidMount() {
    if (this.props.lazy) {
      return;
    }
    this.doFetch();
  };

  Holen.prototype.componentWillUnmount = function componentWillUnmount() {
    this.willUnmount = true;
  };

  Holen.prototype.doFetch = function doFetch(options) {
    var _this2 = this;

    var _Object$assign = Object.assign({}, this.props, options),
        url = _Object$assign.url,
        body = _Object$assign.body,
        credentials = _Object$assign.credentials,
        headers = _Object$assign.headers,
        method = _Object$assign.method;

    this.setState({ fetching: true });

    var updateState = function updateState(error, response) {
      _this2.setState({
        data: response && response.data ? response.data : undefined,
        error: error,
        fetching: false,
        response: response
      }, function () {
        _this2.props.onResponse(error, response);
      });
    };

    return fetch(url, {
      body: body,
      credentials: credentials,
      headers: headers,
      method: method
    }).then(function (res) {
      if (_this2.willUnmount) {
        return;
      }

      return res.json().then(function (data) {
        res.data = data;
        return res;
      }).catch(function (e) {
        updateState(e, res);
        return e;
      });
    }).then(function (res) {
      updateState(undefined, res);
      return res;
    }).catch(function (e) {
      updateState(e, undefined);
      return e;
    });
  };

  Holen.prototype.render = function render() {
    if (!this.props.children) {
      return null;
    }

    var children = childrenToArray(this.props.children);
    return children[0]({
      fetching: this.state.fetching,
      response: this.state.response,
      data: this.state.data,
      error: this.state.error,
      fetch: this.doFetch
    }) || null;
  };

  return Holen;
}(React.Component);

Holen.propTypes = {
  body: PropTypes.any,
  children: PropTypes.func,
  credentials: PropTypes.string,
  headers: PropTypes.object,
  lazy: PropTypes.bool,
  method: PropTypes.oneOf(['get', 'post', 'put', 'delete', 'GET', 'POST', 'PUT', 'DELETE']),
  onResponse: PropTypes.func,
  url: PropTypes.string.isRequired
};

Holen.defaultProps = {
  method: 'get',
  onResponse: function onResponse() {}
};

export default Holen;
//# sourceMappingURL=holen.es.js.map
